Page MenuHomePhabricator

Minimum viable product for Newsletter extension
Closed, ResolvedPublic

Description

The features listed are the ones aimed to be completed before midterm hopefully.

Publisher

  • Create a newsletter - T100125
  • Announce a new issue of an existing newsletter - T101505

Reader

  • Subscribing and unsubscribing to/from a newsletter T100492
  • Receiving a notification for new issues of a subscribed newsletter - Echo notifications - T101546

Unofficial timeline

TaskDeadlinePhabricator taskRemarks
Create a newsletter11 JuneT100125Patch merged
Announce a new issue of an existing newsletter18 JuneT101505Patch merged
Subscribing and unsubscribing to/from a newsletter24 JuneT100492Patch merged
Receiving a notification for new issues of a subscribed newsletter - Echo notifications28 JuneT101546Patch merged

Related Objects

StatusAssignedTask
DuplicateQgil
ResolvedQgil
ResolvedQgil
DeclinedNone
ResolvedAddshore
ResolvedTinaj1234
ResolvedTinaj1234
ResolvedTinaj1234
ResolvedTinaj1234
ResolvedTinaj1234
ResolvedTinaj1234
ResolvedTinaj1234
ResolvedTinaj1234
ResolvedTinaj1234
Resolvedsiebrand
ResolvedTinaj1234
ResolvedTinaj1234
ResolvedTinaj1234
ResolvedTinaj1234
Resolved01tonythomas

Event Timeline

Tinaj1234 claimed this task.
Tinaj1234 raised the priority of this task from to Normal.
Tinaj1234 updated the task description. (Show Details)
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMay 20 2015, 12:40 PM
Tinaj1234 renamed this task from [DRAFT] Define minimum viable product for Newsletter extension to Define minimum viable product for Newsletter extension.May 20 2015, 3:54 PM
Tinaj1234 updated the task description. (Show Details)
Tinaj1234 set Security to None.
Tinaj1234 updated the task description. (Show Details)May 22 2015, 4:33 PM
Tinaj1234 added subscribers: Qgil, 01tonythomas.
Qgil updated the task description. (Show Details)May 23 2015, 9:42 AM
Qgil updated the task description. (Show Details)

We have left just the features, leaving out the implementation details. Each feature should have its own task, and in these tasks we should discuss their implementation. Even if you can find a diff of my edit, I also pasted the previous content here just in case.

Let's agree on the features of the MVP, we left some comments in the description.

Tinaj1234 updated the task description. (Show Details)May 23 2015, 10:48 AM
Tinaj1234 updated the task description. (Show Details)
Tinaj1234 updated the task description. (Show Details)May 23 2015, 12:08 PM
Tinaj1234 updated the task description. (Show Details)
Qgil updated the task description. (Show Details)May 23 2015, 12:53 PM
Tinaj1234 updated the task description. (Show Details)May 23 2015, 1:29 PM
Qgil added a comment.May 23 2015, 1:32 PM

This looks good to me. The related tasks still need to be created, but this MVP looks like a useful prototype that we can bet on. Very good!

Qgil updated the task description. (Show Details)May 24 2015, 3:48 PM
Qgil renamed this task from Define minimum viable product for Newsletter extension to Minimum viable product for Newsletter extension.May 24 2015, 4:09 PM
Qgil updated the task description. (Show Details)
Qgil updated the task description. (Show Details)May 25 2015, 9:36 AM
Qgil updated the task description. (Show Details)May 25 2015, 9:52 AM
Qgil added a comment.May 25 2015, 9:56 AM

@01tonythomas, @Quiddity, and me sat in a room in Lyon and went through the features again, updating the description based on our last discussion. This MVP is sweet and simple now, and perfectly executable. There are some details that we have discussed and still will need to be written down somewhere, but we will wait for @Tinaj1234 to create the tasks for each features to comment.

Isarra added a subscriber: Isarra.May 25 2015, 2:53 PM
gpaumier added a subscriber: gpaumier.EditedMay 28 2015, 5:46 PM

I'm interested to know more about the "Announce a new issue of an existing newsletter" part.

What is the expected workflow for the user (the publisher)? What do they announce? What happens when they announce it? Is this integrated in any way with MassMessage?

I'm interested to know more about the "Announce a new issue of an existing newsletter" part.
What is the expected workflow for the user (the publisher)? What do they announce? What happens when they announce it? Is this integrated in any way with MassMessage?

As of the minimum viable product, we are not planning to integrate with MassMessage as of now.
Current high level plan ( we miss a sub-task for this. @Tinaj1234: can you make one for each points listed over there in the MVP basics ? ):

  1. Publisher already has his new issue somewhere as a wiki-page ( preferably as a subpage of the main home-page )
  2. Publisher goes to Special:NewsLetterPublishers where he see his newsletters listed and an option next to it 'Add a new Issue'
  3. Publisher clicks on it and is asked to type in the URL/Page name of the 'New Issue' page. On clicking 'Add' its added to the database, and is shown up under the 'Newsletter' name
  4. The Publisher should get an 'Announce Issue' button also for the new entry so that clicking it would send Echo notifications to everyone subscribed ( we are storing subscriptions in db - so this wont be an issue )

@01tonythomas Thank you for the detailed response! It's much clearer now. Your plan sounds good to me.

One thing I want to mention is subscribers metrics; One advantage of MassMessage is that, since people sign up on a wiki page, we can count how many subscribers there are for a specific newsletter.

If people choose so subscribe via Echo notifications instead of MassMessage, we need a mechanism to know how many people are getting a notification, and if possible on how many wikis.

Qgil updated the task description. (Show Details)Jun 5 2015, 11:11 AM
01tonythomas updated the task description. (Show Details)Jun 5 2015, 7:18 PM
Tinaj1234 updated the task description. (Show Details)Jun 8 2015, 10:55 AM
Qgil updated the task description. (Show Details)Jun 8 2015, 11:29 AM

I think the Specail:NewsletterPublishers should have 3 sections:

  1. Announce a new issue ( this should come in top - as a new issue is more frequent than a new Newsletter )
  2. Create a new issue - The fields as discussed with its own 'Create' button.
  3. Manage an existing newsletter ( things like, adding a new collaborator to an existing newsletter should come over here. This would mean that while creating - we can just set the 'creator' is the lone 'collaborator' for the new 'Newsletter'. Additional collaborators can be added 'one' at a time by sliding down to 'Manage Newsletters' -> selecting corresponding newsletter from a drop down menu -> Typing in name of a new collaborator -> clicking a 'Save' button for that section. )

Sounds sane ?

1 and 2 were already agreed in this order at T100125#1309184. If there is more to about these two sections, we can discuss them in that task.

"Manage an existing newsletter" was a feature explicitly left out of the MVP, and I would not focus on it right now. The bottom of Special:NewsletterPublishers sounds like a good candidate yes. Feel free to create a new task "Managing an existing newsletter" for whoever wants to discuss it now, but Tina should be able to forget about it until the MVP is complete.

01tonythomas added a comment.EditedJun 9 2015, 1:21 PM

"Manage an existing newsletter" was a feature explicitly left out of the MVP, and I would not focus on it right now. The bottom of Special:NewsletterPublishers sounds like a good candidate yes. Feel free to create a new task "Managing an existing newsletter" for whoever wants to discuss it now, but Tina should be able to forget about it until the MVP is complete.

Created T101832

Sure, ""Manage an existing newsletter" is a definite feature for newsletter extension. Will work on T101832 after midterm, i.e after MVP is done.

Qgil added a comment.Jun 18 2015, 6:41 AM

GSoC's mid-term is starting next Friday, 26 June. As of today, none of the four tasks/features of this MVP has been marked as resolved. As you can see, it makes total sense to focus on these features and their dependencies, and basically forget about all the rest.

Two of the features have almost reached their finish lines and we have already started on the third ( subscribing/unsubscribing ). I tried updating the vagrant so as to show everyone the developments but I have few issues sshing to vagrant. We can discuss more on developments on today's meetings if there are more concerns.

We have newsletters currently. We publish them as wiki pages and we distribute them with mailing lists and talk page messages (using the MassMessage extension).

What problems is this proposed Newsletter extension intended to solve?

What problems is this proposed Newsletter extension intended to solve?

This is answered at T76199: Goal: Newsletter extension for MediaWiki.

Tinaj1234 updated the task description. (Show Details)Jun 23 2015, 10:15 AM
Tinaj1234 updated the task description. (Show Details)Jun 23 2015, 1:44 PM

Getting there! Just a very simple thing: can you edit http://newsletter-test.wmflabs.org/wiki/Main_Page adding the links to the Special:Newsletter related pages available? Nothing fancy, just an informative bullet list.

01tonythomas added a comment.EditedJun 26 2015, 7:46 PM

I would recommend making it a bit more verbose even though it looks fine now. Just add one or more line on what gives what, and thats it !

Tinaj1234 added a comment.EditedJun 26 2015, 8:07 PM

I would recommend making it a bit more verbose even though it looks fine now. Just add one or more line on what gives what, and thats it !

Done.

Mmm... has @Tinaj1234 just completed the MVP? :)

It looks like :) Yes !

@01tonythomas, @Qgil Looks like we are done with the MVP. Closing task :)

Tinaj1234 closed this task as Resolved.Jun 29 2015, 7:45 AM